package com.tencent.tic.demo;

import android.app.Activity;
import android.app.Application;
import android.os.Bundle;
import android.util.Log;

import com.tencent.tic.core.BoardManager;
import com.tencent.tic.core.IMManager;
import com.tencent.tic.core.TextUtil;
import com.tencent.tic.demo.activities.BaseActvity;

/**
 * Created by ericczhuangzhang on 2017/9/29.
 */
public class TICSDKDemoApp extends Application {
    private final static String TAG = "TICSDKDemoApp";
    private boolean isBackGround = false;
    private double enterBackgroundTime = 0.0;


    @Override
    public void onCreate() {
        super.onCreate();
        TextUtil.context = this;
        IMManager.getInstance().initSDK(this, BaseActvity.sdkAppId);
        registerActivityLifecycleCallbacks(new ActivityLifecycleCallbacks() {
            @Override
            public void onActivityResumed(Activity activity) {
                if (isBackGround) {
                    isBackGround = false;
                    double time = System.currentTimeMillis() * 1000 - enterBackgroundTime;
                    if (time >= 30 && BoardManager.getInstance().getBoardController() != null) {
                        BoardManager.getInstance().getBoardController().syncAndReload();
                    }
                    Log.i("bo", TextUtil.getString(R.string.app_foreground));
                }
            }

            @Override
            public void onActivityCreated(Activity activity, Bundle savedInstanceState) {
            }

            @Override
            public void onActivityStarted(Activity activity) {
            }



            @Override
            public void onActivityPaused(Activity activity) {
            }

            @Override
            public void onActivityStopped(Activity activity) {
            }

            @Override
            public void onActivitySaveInstanceState(Activity activity, Bundle outState) {
            }

            @Override
            public void onActivityDestroyed(Activity activity) {
            }
        });
    }

    @Override
    public void onTrimMemory(int level) {
        super.onTrimMemory(level);
        if (level == TRIM_MEMORY_UI_HIDDEN) {
            isBackGround = true;
            enterBackgroundTime = System.currentTimeMillis() * 1000;
            Log.i("bo", TextUtil.getString(R.string.app_background));
        }
    }


    public  abstract class Test implements testIMEListener{
        @Override
        public void callTest() {
            
        }
    }

    public interface  testIMEListener{
        void callTest();
    }
  
    @Override
    public void onTerminate() {
        IMManager.getInstance().unInitSDK();
        super.onTerminate();
    }

}
