package com.tencent.tic.demo.activities;

import android.os.Bundle;
import android.util.Log;
import android.widget.TextView;
import android.widget.Toast;

import com.tencent.tic.core.IMManager;
import com.tencent.tic.core.TextUtil;
import com.tencent.tic.demo.R;

import androidx.appcompat.app.AppCompatActivity;


public class BaseActvity extends AppCompatActivity implements IMManager.TIMCallBack {

    final String TAG = this.getClass().getSimpleName();
    final static int REQUEST_CODE = 1;

    public final static int sdkAppId = 1400127140;
    protected final static String USER_ID = "USER_ID";
    protected final static String USER_SIG = "USER_SIG";
    protected final static String USER_ROOM = "USER_ROOM";
    protected final static String USER_IM_GROUP = "USER_IM_GROUP";
    protected final static String USER_NICKNAME = "USER_NICKNAME";


    //账号信息
    protected String mUserID;
    protected String mUserSig;
    protected int mRoomId;
    protected String mGroupID;
    protected String mNickName;

    //日志信息
    String logMsg = "";
    TextView tvLog;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        IMManager.getInstance().addCallback(this);
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        IMManager.getInstance().removeCallback(this);
    }

    public void postToast(String msg) {
        postToast(msg, false);
    }

    protected void postToast(final String msg, final boolean toast) {
        Log.i(TAG, msg);

        this.runOnUiThread(new Runnable() {
            @Override
            public void run() {
                if (toast) {
                    Toast.makeText(BaseActvity.this, msg, Toast.LENGTH_SHORT).show();
                }
                addLog(msg);
            }
        });
    }

    protected void addLog(String logs) {
        if (tvLog != null) {
            logMsg = logMsg + "\r\n" + logs;
            tvLog.setText(logMsg + "\r\n");

            int offset = tvLog.getLineCount() * tvLog.getLineHeight();
            if (offset > tvLog.getHeight()) {
                tvLog.scrollTo(0, offset - tvLog.getHeight());
            }
        }
    }

    @Override
    public void onTIMForceOffline() {
        postToast(TextUtil.getString(R.string.you_have_been_logged_out), true);
    }

    @Override
    public void onTIMUserSigExpired() {
        postToast(TextUtil.getString(R.string.user_signature_expired), true);
    }

    // IM掉线
    @Override
    public void onConnectFailed(int code, String error) {
        postToast(TextUtil.getString(R.string.im_disconnected), true);
    }
}