package com.tencent.tic.demo.activities;

import static com.tencent.teduboard.TEduBoardController.TEduBoardElementType.TEDU_BOARD_ELEMENT_H5;
import static com.tencent.teduboard.TEduBoardController.TEduElementOperatorType.ROTATION_ANGLE;

import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Color;
import android.graphics.Point;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.text.TextUtils;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.View;
import android.widget.EditText;
import android.widget.FrameLayout;
import android.widget.TextView;
import android.widget.Toast;

import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;

import com.tencent.teduboard.TEduBoardController;
import com.tencent.tic.core.BoardManager;
import com.tencent.tic.core.IMManager;
import com.tencent.tic.core.TextUtil;
import com.tencent.tic.demo.R;

import org.json.JSONArray;
import org.json.JSONObject;

import java.lang.ref.WeakReference;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class TICClassMainActivity extends BaseActvity
        implements View.OnClickListener {
    private final static String TAG = "TICClassMainActivity";
    private static String kUpdateElementUrl = TextUtil.getString(R.string.update_element_url);
    private static String kPermissionUrl = TextUtil.getString(R.string.permission_url);
    private static String kAddWatermarkUrl = TextUtil.getString(R.string.add_watermark_url);
    private static String kAddVideoFileUrl = TextUtil.getString(R.string.add_video_url);
    private static String kAddH5Url = TextUtil.getString(R.string.add_h5_url);
    private static String kAddTranscodeUrl = TextUtil.getString(R.string.add_transcode_file);
//    private final static String kUpdateElementUrl = "http://localhost:8080/#/UpdateElement";
//    private final static String kPermissionUrl = "http://localhost:8080/#/Permission";
//    private final static String kAddWatermarkUrl = "http://localhost:8080/#/AddWatermark";
//    private final static String kAddVideoFileUrl = "http://localhost:8080/#/AddVideoFile";

    TICMenuDialog moreDlg;
    MySettingCallback mySettingCallback;
    boolean mEnableAudio = true;
    boolean mEnableCamera = true;
    boolean mEnableFrontCamera = true;
    boolean mEnableAudioRouteSpeaker = true; //扬声器
    boolean mCanRedo = false;
    boolean mCanUndo = false;
    boolean nickNameVisiable = true;
    boolean mEnableMultiTouch = false;
    boolean mAutoSelect = false;
    int mMagicPenType = 0;
    /**
     * 白板视图控件
     */
    FrameLayout mBoardContainer;
    TEduBoardController mBoard;
    Boolean mDisableTouch = false;
    Boolean mSegmentEraser = false;
    String mDataExported;
    MyBoardCallback mBoardCallback;
    boolean mHistroyDataSyncCompleted = false;

    // 消息输入
    String mImgsFid;
    String mAudioElementId;

    private EditText inputEt;
    private String textH5Id;
    private String textH5Status;

    PopWebView popWebView;
    boolean webviewFinshed;
    TEduBoardController.TEduBoardElement currentElement;

    JSONObject permissionObj;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_class_ex);

        kUpdateElementUrl = TextUtil.getString(R.string.update_element_url);
        kPermissionUrl = TextUtil.getString(R.string.permission_url);
        kAddWatermarkUrl = TextUtil.getString(R.string.add_watermark_url);
        kAddVideoFileUrl = TextUtil.getString(R.string.add_video_url);

        //在白板上文本输入时，避免出现软键盘盖住情况。
        // getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_ADJUST_PAN);
        //1、获取用户信息
        mUserID = getIntent().getStringExtra(USER_ID);
        mUserSig = getIntent().getStringExtra(USER_SIG);
        mRoomId = getIntent().getIntExtra(USER_ROOM, 0);
        mGroupID = getIntent().getStringExtra(USER_IM_GROUP);
        mNickName = getIntent().getStringExtra(USER_NICKNAME);

        //3、初始化View
        initView();

//        QbSdk.forceSysWebView();

        joinClass();
    }


    @Override
    protected void onStop() {
        if (isFinishing()) {
            BoardManager.getInstance().destroyBoard();
        }
        super.onStop();
    }

    @Override
    protected void onDestroy() {
        removeBoardView();
        super.onDestroy();
    }


    private void initView() {
        //Title
        findViewById(R.id.tv_double_room_back_button).setOnClickListener(this);
        findViewById(R.id.tv_memu).setOnClickListener(this);
        ((TextView) findViewById(R.id.tv_room_id)).setText(String.valueOf(mRoomId));

        tvLog = (TextView) findViewById(R.id.tv_log);
      //  tvLog.setMovementMethod(ScrollingMovementMethod.getInstance());
        ((EditText) findViewById(R.id.test_color)).setText("#FF00FF00");
        findViewById(R.id.btn_color).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String color = ((EditText) findViewById(R.id.test_color)).getText().toString();
                int tempColor = Color.parseColor(color);
                boardview.setBackgroundColor(tempColor);
            }
        });
    }

    void setPermission(JSONObject jsonObject) {
        this.permissionObj = jsonObject;
        Map<String, String> permissionMap = new HashMap<String, String>();
        permissionMap.put(TextUtil.getString(R.string.set_background_color), "Background::Update::Color");
        permissionMap.put(TextUtil.getString(R.string.set_background_frame), "Background::Update::Frame");
        permissionMap.put(TextUtil.getString(R.string.set_background_image), "Background::Update::Image");
        permissionMap.put(TextUtil.getString(R.string.add_board), "Board::Add");
        permissionMap.put(TextUtil.getString(R.string.clear_whiteboard), "Board::Clear");
        permissionMap.put(TextUtil.getString(R.string.delete_whiteboard),"Board::Delete");
        permissionMap.put(TextUtil.getString(R.string.zoom_whiteboard), "Board::Scale::*");
        permissionMap.put(TextUtil.getString(R.string.switch_whiteboard), "Board::Switch::Page");
        permissionMap.put(TextUtil.getString(R.string.switch_step), "Board::Switch::Step");
        permissionMap.put(TextUtil.getString(R.string.update_whiteboard_fill_mode), "Board::Update::ContentFitMode");
        permissionMap.put(TextUtil.getString(R.string.update_whiteboard_ratio), "Board::Update::Ratio");
        permissionMap.put(TextUtil.getString(R.string.to_redo), "Board::Undo::*");
        permissionMap.put(TextUtil.getString(R.string.redo), "Board::Redo::*");
        permissionMap.put(TextUtil.getString(R.string.add_element), "Element::Add::*");
        permissionMap.put(TextUtil.getString(R.string.delete_element), "Element::Delete::*");
        permissionMap.put(TextUtil.getString(R.string.select_element), "Element::Select::*");
        permissionMap.put(TextUtil.getString(R.string.update_element), "Element::Update::*");
        permissionMap.put(TextUtil.getString(R.string.add_file), "File::Add");
        permissionMap.put(TextUtil.getString(R.string.clear_files), "File::Clear");
        permissionMap.put(TextUtil.getString(R.string.delete_file), "File::Delete");
        permissionMap.put(TextUtil.getString(R.string.switch_file), "File::Switch");
        permissionMap.put(TextUtil.getString(R.string.update_file), "File::Update::*");
        permissionMap.put(TextUtil.getString(R.string.reset_whiteboard), "Instance::Reset");
        List<String> havePermissionArray = new ArrayList<String>();
        List<String> noPermissionArray = new ArrayList<String>();
        List<String> disableArray = new ArrayList<String>();
        JSONArray array = jsonObject.optJSONArray("backgroundCheckList");
        if (array != null) {
            String[] background = {TextUtil.getString(R.string.set_background_color), TextUtil.getString(R.string.set_background_frame), TextUtil.getString(R.string.set_background_image)};
            if(jsonObject.optInt("background") == 1) {
                // 开启了背景权限校验
                for (int i = 0; i < background.length; i++) {
                    String key = background[i];
                    String value = permissionMap.get(key);
                    boolean found = false;
                    for (int j = 0; j < array.length(); j++) {
                        if (array.optString(j).equals(key)) {
                            found = true;
                            break;
                        }
                    }
                    if(found) {
                        havePermissionArray.add(value);
                    } else  {
                        noPermissionArray.add(value);
                    }
                }
            }
            else {
                // 关闭了背景权限校验
                disableArray.add("Background::*");
            }
        }

        array = jsonObject.optJSONArray("boardCheckList");
        if (array != null) {
            String[] tmpArray = {TextUtil.getString(R.string.add_board), TextUtil.getString(R.string.clear_whiteboard),
                    TextUtil.getString(R.string.delete_whiteboard), TextUtil.getString(R.string.zoom_whiteboard),
                    TextUtil.getString(R.string.switch_whiteboard), TextUtil.getString(R.string.switch_step),
                    TextUtil.getString(R.string.update_whiteboard_fill_mode), TextUtil.getString(R.string.update_whiteboard_ratio),
                    TextUtil.getString(R.string.to_redo), TextUtil.getString(R.string.redo),
                    TextUtil.getString(R.string.reset_whiteboard)};
            if(jsonObject.optInt("board") == 1) {
                // 开启了白板权限校验
                for (int i = 0; i < tmpArray.length; i++) {
                    String key = tmpArray[i];
                    String value = permissionMap.get(key);
                    boolean found = false;
                    for (int j = 0; j < array.length(); j++) {
                        if (array.optString(j).equals(key)) {
                            found = true;
                            break;
                        }
                    }
                    if(found) {
                        havePermissionArray.add(value);
                    } else  {
                        noPermissionArray.add(value);
                    }
                }
            }
            else {
                // 关闭了白板权限校验
                disableArray.add("Board::*");
            }
        }

        array = jsonObject.optJSONArray("elementCheckList");
        if (array != null) {
            String[] tmpArray = {TextUtil.getString(R.string.add_element), TextUtil.getString(R.string.delete_element), TextUtil.getString(R.string.select_element), TextUtil.getString(R.string.update_element)};
            if(jsonObject.optInt("element") == 1) {
                // 开启了元素权限校验
                for (int i = 0; i < tmpArray.length; i++) {
                    String key = tmpArray[i];
                    String value = permissionMap.get(key);
                    boolean found = false;
                    for (int j = 0; j < array.length(); j++) {
                        if (array.optString(j).equals(key)) {
                            found = true;
                            break;
                        }
                    }
                    if(found) {
                        havePermissionArray.add(value);
                    } else  {
                        noPermissionArray.add(value);
                    }
                }
            }
            else {
                // 关闭了元素权限校验
                disableArray.add("Element::*");
            }
        }

        array = jsonObject.optJSONArray("fileCheckList");
        if (array != null) {
            String[] tmpArray = {TextUtil.getString(R.string.add_file), TextUtil.getString(R.string.clear_files), TextUtil.getString(R.string.delete_file), TextUtil.getString(R.string.switch_file), TextUtil.getString(R.string.update_file)};
            if(jsonObject.optInt("file") == 1) {
                // // 开启了文件权限校验
                for (int i = 0; i < tmpArray.length; i++) {
                    String key = tmpArray[i];
                    String value = permissionMap.get(key);
                    boolean found = false;
                    for (int j = 0; j < array.length(); j++) {
                        if (array.optString(j).equals(key)) {
                            found = true;
                            break;
                        }
                    }
                    if(found) {
                        havePermissionArray.add(value);
                    } else  {
                        noPermissionArray.add(value);
                    }
                }
            }
            else {
                // 关闭了文件权限校验
                disableArray.add("File::*");
            }
        }

//        mBoard.resetPermissionChecker();
        if (havePermissionArray.size() > 0) {
            List<String> filters = new ArrayList<String>();
            filters.add("operator/"+ mUserID);
            mBoard.enablePermissionChecker(havePermissionArray, filters);
        }
        if (noPermissionArray.size() > 0) {
            List<String> filters = new ArrayList<String>();
            filters.add("operator/");
            mBoard.enablePermissionChecker(noPermissionArray, filters);
        }
        if (disableArray.size() > 0) {
            mBoard.disablePermissionChecker(disableArray);
        }
    }
    private void closePopWebview() {
        if (this.popWebView != null) {
            this.mBoardContainer.removeView(this.popWebView);
            this.popWebView = null;
        }
    }
    private void openPopWebview(String url) {
        this.closePopWebview();
        this.popWebView = new PopWebView(this);
        FrameLayout.LayoutParams layout = new FrameLayout.LayoutParams(FrameLayout.LayoutParams.MATCH_PARENT, FrameLayout.LayoutParams.MATCH_PARENT);
        mBoardContainer.addView(this.popWebView, layout);
        this.popWebView.setListener(new PopWebView.PopWebViewListener() {
            @Override
            public void onReceiveH5Msg(final JSONObject msg) {
                TICClassMainActivity.this.runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        TICClassMainActivity.this.handlePopWebviewMsg(msg);
                    }
                });
            }
        });
        this.popWebView.loadUrl(url);

    }
    private void handlePopWebviewMsg(JSONObject msg) {
        JSONObject jsonObject = msg;
        String action = jsonObject.optString("action");
        if (action.equals("setElementStyle")) {
            int styleType = Integer.parseInt(jsonObject.optString("styleType"));
            if (styleType == TEduBoardController.TEduElementOperatorType.EL_DELETE) {
                String styleValue = jsonObject.optString("styleValue");
                this.mBoard.updateElementById(this.currentElement.elementId, styleType, styleValue);
                this.closePopWebview();
            }
            else if(styleType == TEduBoardController.TEduElementOperatorType.CHANGE_POSITION) {
                JSONObject styleValue = jsonObject.optJSONObject("styleValue");
                this.mBoard.updateElementById(this.currentElement.elementId,
                        styleType,
                        styleValue.optInt("y"),
                        styleValue.optInt("x"));
            }
            else {
                String styleValue = jsonObject.optString("styleValue");
                this.mBoard.updateElementById(this.currentElement.elementId, styleType, styleValue);
            }
        }
        else if (action.equals("addVideoFile")) {
            JSONObject valueObj = jsonObject.optJSONObject("value");
            String url = valueObj.optString("url");
            String title = valueObj.optString("title");
            this.mBoard.addVideoFile(url, title, true);
        }
        else if (action.equals("addElement")) {
            int type = jsonObject.optInt("type");
            JSONObject valueObj = jsonObject.optJSONObject("value");
            if (type == TEduBoardController.TEduBoardElementType.TEDU_BOARD_ELEMENT_WATERMARK) {
                TEduBoardController.TEduBoardElementWatermark params = new TEduBoardController.TEduBoardElementWatermark();
                params.content = valueObj.optString("content");
                params.left = valueObj.optString("left");
                params.top = valueObj.optString("top");
                params.width = valueObj.optString("width");
                params.height = valueObj.optString("height");
                params.opacity = Float.valueOf(valueObj.optString("opacity"));
                this.mBoard.addElementWatermark(params);
            }
        }
        else if(action.equals("closeWebview")) {
            this.closePopWebview();
        }
        else if(action.equals("showToast")) {
            String content = jsonObject.optString("content");
            if (content != null && content.length() > 0) {
                this.postToast(content, true);
            }
        }
        else if(action.equals("setPermission")) {
            this.setPermission(jsonObject.optJSONObject("content"));
            this.closePopWebview();
        }
        else if (action.equals("addH5File")) {
            JSONObject valueObj = jsonObject.optJSONObject("value");
            String url = valueObj.optString("url");
            int angle = valueObj.optInt("angle");
            String elementId = this.mBoard.addElement(TEDU_BOARD_ELEMENT_H5, url);
            this.mBoard.updateElementById(elementId, ROTATION_ANGLE, angle);
        }
        else if (action.equals("addTransCodeFile")) {
            JSONObject valueObj = jsonObject.optJSONObject("value");
            String url = valueObj.optString("url");
            String title = valueObj.optString("title");
            int pages = valueObj.optInt("pages");
            TEduBoardController.TEduBoardTranscodeFileResult result = new TEduBoardController.TEduBoardTranscodeFileResult(title, url, pages, "1000*1000");
            this.mBoard.addTranscodeFile(result, true);
//            String elementId = this.mBoard.addElement(TEDU_BOARD_ELEMENT_H5, url);
//            this.mBoard.updateElementById(elementId, ROTATION_ANGLE, angle);
        }
    }

    boolean checkPermissions() {
        String[] PERMISSIONS = {
                "android.permission.READ_EXTERNAL_STORAGE",
                "android.permission.WRITE_EXTERNAL_STORAGE" };
//检测是否有写的权限
        int permission = ContextCompat.checkSelfPermission(this,
                "android.permission.WRITE_EXTERNAL_STORAGE");
        if (permission != PackageManager.PERMISSION_GRANTED) {
            // 没有写的权限，去申请写的权限，会弹出对话框
            ActivityCompat.requestPermissions(this, PERMISSIONS,1);
            return false;
        }
        return true;
    }
    //------回调设置的处理------
    class MySettingCallback implements TICMenuDialog.IMoreListener {

        @Override
        public void onEnableAudio(boolean bEnableAudio) {
            mEnableAudio = bEnableAudio;
        }

        @Override
        public void onSwitchAudioRoute(boolean speaker) {
            mEnableAudioRouteSpeaker = speaker;
        }

        @Override
        public void onEnableCamera(boolean bEnableCamera) {
            mEnableCamera = bEnableCamera;
        }

        @Override
        public void onSwitchCamera(boolean bFrontCamera) {
            mEnableFrontCamera = bFrontCamera;
        }

        //------------board------------
        @Override
        public void onSetDrawEnable(boolean SetDrawEnable) {
            mBoard.setDrawEnable(SetDrawEnable);
        }

        @Override
        public void onSyncDrawEnable(boolean syncDrawEnable) {
            mBoard.setDataSyncEnable(syncDrawEnable);
        }

        @Override
        public void onMultiTouchEnable(boolean enableMultiTouch) {
            mEnableMultiTouch = enableMultiTouch;
            mBoard.enableMultiTouch(enableMultiTouch);
            mBoard.setSyncFps(10);
        }

        @Override
        public void onTouchEnable(boolean enableMultiTouch) {
            mBoard.disablePointerEventResponding(!enableMultiTouch);
            mDisableTouch = !enableMultiTouch;
        }

        @Override
        public void onSegmentEraser(boolean segmentEraser) {
            mBoard.setPiecewiseErasureEnable(segmentEraser);
            mSegmentEraser = segmentEraser;
        }

        @Override
        public void onStartSnapshot() {
            if (checkPermissions()) {
                TEduBoardController.TEduBoardSnapshotInfo snapshotInfo = new TEduBoardController.TEduBoardSnapshotInfo();
                long now = System.currentTimeMillis();
                snapshotInfo.path = Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_DCIM).getPath() + "/" + now + ".png";
                mBoard.snapshot(snapshotInfo);
            }
        }

        @Override
        public void onNextTextInput(String textContent, boolean keepFocus) {
            mBoard.setNextTextInput(textContent, keepFocus);
        }

        @Override
        public void onAutoSelect(boolean autoSelect) {
            mAutoSelect = autoSelect;
        }

        @Override
        public void onTipTextInput(String textContent) {
            TEduBoardController.TEduBoardToolTypeTitleStyle titleStyle
                    = new TEduBoardController.TEduBoardToolTypeTitleStyle();
            titleStyle.color = "#FF0000";
            titleStyle.size = 1000;
            titleStyle.style = TEduBoardController.TEduBoardTextStyle.TEDU_BOARD_TEXT_STYLE_BOLD_ITALIC;
            titleStyle.position = TEduBoardController.TEduBoardPosition.TEDU_BOARD_POSITION_RIGHT_TOP;

            mBoard.setToolTypeTitle(textContent, titleStyle, TEduBoardController.TEduBoardToolType.TEDU_BOARD_TOOL_TYPE_ERASER);
        }

        @Override
        public void onWipeNumInput(int num) {
            mBoard.setEraseLayerLimit(num);
        }

        @Override
        public void onSetHandwritingEnable(boolean writingEnable) {
            mBoard.setHandwritingEnable(writingEnable);
        }

        @Override
        public void onSetToolType(int type) {
            TEduBoardController.TEduBoardGraphStyle style = new TEduBoardController.TEduBoardGraphStyle();
            style.fillType = TEduBoardController.TEduBoardFillType.TEduBoardFillTypeNONE;
            style.lineType = TEduBoardController.TEduBoardLineType.TEDU_BOARD_LINE_TYPE_SOLID;
            style.startArrowType = TEduBoardController.TEduBoardArrowType.TEDU_BOARD_ARROW_TYPE_NONE;
            style.endArrowType = TEduBoardController.TEduBoardArrowType.TEDU_BOARD_ARROW_TYPE_NONE;
            if(type == TEduBoardController.TEduBoardToolType.TEDU_BOARD_TOOL_TYPE_OVAL_SOLID
                    || type == TEduBoardController.TEduBoardToolType.TEDU_BOARD_TOOL_TYPE_RECT_SOLID
                    || type == TEduBoardController.TEduBoardToolType.TEDU_BOARD_TOOL_TYPE_SQUARE_SOLID
                    || type == TEduBoardController.TEduBoardToolType.TEDU_BOARD_TOOL_TYPE_CIRCLE_SOLID) {
                style.fillType = TEduBoardController.TEduBoardFillType.TEduBoardFillTypeSOLID;
            }
            mBoard.setGraphStyle(style);
            mBoard.setToolType(type);
        }

        @Override
        public void onSetMagicPen(int type) {
            mMagicPenType = type;
            if (type == 0) {
                mBoard.enablePenAutoFit(false, 0);
                mBoard.setPenAutoFittingMode(TEduBoardController.TEduBoardPenFittingMode.NONE);
            }
            else if (type == 1) {
                mBoard.enablePenAutoFit(false, 0);
                mBoard.setPenAutoFittingMode(TEduBoardController.TEduBoardPenFittingMode.AUTO);
            }
            else if (type == 2) {
                mBoard.setPenAutoFittingMode(TEduBoardController.TEduBoardPenFittingMode.NONE);
                mBoard.enablePenAutoFit(true, 2000);
            }
        }

        @Override
        public void onSetGraphStyle(int type) {
            if (type == 0) {
                mBoard.setGraphStyle(TEduBoardController.TEduBoardGraphStyle.dashedLineNoArrow());
                mBoard.setToolType(TEduBoardController.TEduBoardToolType.TEDU_BOARD_TOOL_TYPE_LINE);
            }
            else if(type == 1) {
                mBoard.setGraphStyle(TEduBoardController.TEduBoardGraphStyle.solidLineEndArrow());
                mBoard.setToolType(TEduBoardController.TEduBoardToolType.TEDU_BOARD_TOOL_TYPE_LINE);
            }
            else if(type == 2) {
                mBoard.setGraphStyle(TEduBoardController.TEduBoardGraphStyle.dashedLineStartArrow());
                mBoard.setToolType(TEduBoardController.TEduBoardToolType.TEDU_BOARD_TOOL_TYPE_LINE);
            }
            else if(type == 3) {
                mBoard.setGraphStyle(TEduBoardController.TEduBoardGraphStyle.solidLineBothArrow());
                mBoard.setToolType(TEduBoardController.TEduBoardToolType.TEDU_BOARD_TOOL_TYPE_LINE);
            }
            else if(type == 4) {
                mBoard.setGraphStyle(TEduBoardController.TEduBoardGraphStyle.solidTriangle());
                mBoard.setToolType(TEduBoardController.TEduBoardToolType.TEDU_BOARD_TOOL_TYPE_RIGHT_TRIANGLE);
            }
            else if(type == 5) {
                mBoard.setGraphStyle(TEduBoardController.TEduBoardGraphStyle.dashedRect());
                mBoard.setToolType(TEduBoardController.TEduBoardToolType.TEDU_BOARD_TOOL_TYPE_RECT);
            }
            else if(type == 6) {
                TEduBoardController.TEduBoardGraphStyle style = new TEduBoardController.TEduBoardGraphStyle();
                style.fillType = TEduBoardController.TEduBoardFillType.TEduBoardFillTypeSOLID;
                mBoard.setGraphStyle(style);
                mBoard.setToolType(TEduBoardController.TEduBoardToolType.TEDU_BOARD_TOOL_TYPE_ISOSCELES_TRIANGLE);
            }
            else if(type == 7) {
                TEduBoardController.TEduBoardGraphStyle style = new TEduBoardController.TEduBoardGraphStyle();
                style.fillType = TEduBoardController.TEduBoardFillType.TEduBoardFillTypeSOLID;
                mBoard.setGraphStyle(style);
                mBoard.setToolType(TEduBoardController.TEduBoardToolType.TEDU_BOARD_TOOL_TYPE_RIGHT_TRIANGLE);
            }
            else if(type == 8) {
                TEduBoardController.TEduBoardGraphStyle style = new TEduBoardController.TEduBoardGraphStyle();
                style.fillType = TEduBoardController.TEduBoardFillType.TEduBoardFillTypeSOLID;
                mBoard.setGraphStyle(style);
                mBoard.setToolType(TEduBoardController.TEduBoardToolType.TEDU_BOARD_TOOL_TYPE_PARALLELOGRAM);
            }
        }

        @Override
        public void onSetMathToolType(int type) {
            mBoard.useMathTool(type);
        }

        @Override
        public void onBrushThin(int size) {
            mBoard.setBrushThin(size);
        }

        @Override
        public void onSetTextSize(int size) {
            mBoard.setTextSize(size);
        }

        @Override
        public void onSetEraserSize(int size) {
            mBoard.setEraserSize(size);
        }

        @Override
        public void onSetTextHeight(float height) {
            mBoard.setTextLineHeight(height);
        }

        @Override
        public void onAddElement(int type, String url) {
            String elementId = mBoard.addElement(type, url);
            if (type == 4) {
                mAudioElementId = elementId;
            }
            Log.d("evaluateJs", "onAddElement elementId: " + elementId + " mAudioElementId: " + mAudioElementId);
        }

        @Override
        public void onSetBrushColor(int color) {
            TEduBoardController.TEduBoardColor eduBoardColor = new TEduBoardController.TEduBoardColor(color);
            mBoard.setBrushColor(eduBoardColor);
        }

        @Override
        public void onSetTextColor(int color) {
            TEduBoardController.TEduBoardColor eduBoardColor = new TEduBoardController.TEduBoardColor(color);
            mBoard.setTextColor(eduBoardColor);
        }

        @Override
        public void onSetHighlightColor(int color) {
            TEduBoardController.TEduBoardColor eduBoardColor = new TEduBoardController.TEduBoardColor(color);
            mBoard.setHighlighterColor(eduBoardColor);
        }

        @Override
        public void onSetTextStyle(int style) {
            mBoard.setTextStyle(style);
        }

        @Override
        public void onSetBackgroundColore(int color) {
            TEduBoardController.TEduBoardColor eduBoardColor = new TEduBoardController.TEduBoardColor(color);
            mBoard.setBackgroundColor(eduBoardColor);
        }

        @Override
        public void onSetGlobalBackgroundColore(int color) {
            TEduBoardController.TEduBoardColor eduBoardColor = new TEduBoardController.TEduBoardColor(color);
            mBoard.setGlobalBackgroundColor(eduBoardColor);
        }

        @Override
        public void onSetBackgroundImage(String path) {
            if (!TextUtils.isEmpty(path)) {
                mBoard.setBackgroundImage(path, TEduBoardController.TEduBoardImageFitMode.TEDU_BOARD_IMAGE_FIT_MODE_CENTER);
            }
        }

        @Override
        public void onSetBackgroundH5(String url) {
            if (!TextUtils.isEmpty(url)) {
                mBoard.setBackgroundH5(url);
            }
        }

        @Override
        public void setWipeType(int wipeType) {
            List<Integer> typeArray = new ArrayList<>();
            typeArray.add(wipeType);
            mBoard.setEraseLayerType(typeArray);
        }

        @Override
        public void onSetNickNameVisiable(boolean visiable) {
            nickNameVisiable = visiable;
            mBoard.setOwnerNickNameVisible(visiable);
        }

        @Override
        public void onUndo() {
            mBoard.undo();
        }

        @Override
        public void onRedo() {
            mBoard.redo();
        }

        @Override
        public void onClear() {
            mBoard.clear(true);
        }
        @Override
        public void onClearDraws() {
            mBoard.clear(false);
        }

        @Override
        public void onClearBackground() {
            mBoard.setBackgroundImage("", 0);
        }

        @Override
        public void onReset() {
            mBoard.reset();
        }

        @Override
        public void onSetPermission() {
            TICClassMainActivity.this.openPopWebview(TICClassMainActivity.this.kPermissionUrl);
            TICClassMainActivity.this.popWebView.sendToH5("setPermission", TICClassMainActivity.this.permissionObj);
            moreDlg.dismiss();
        }

        @Override
        public void onAddBoard(String url, int index) {
            mBoard.addBoard(url, 0, 0, true, index);
        }

        @Override
        public void onDeleteBoard(String boardId) {
            mBoard.deleteBoard(boardId);
        }

        @Override
        public void onGotoBoard(String boardId) {
               mBoard.gotoBoard(boardId);
//            for (int i = 0; i < 50; i++) {
//                String fileId = mBoard.getCurrentFile();
//                mBoard.getFileInfo(fileId);
//            }
        }

        @Override
        public void onPrevStep() {
            mBoard.prevStep();
        }

        @Override
        public void onNextStep() {
            mBoard.nextStep();
        }

        @Override
        public void onPrevBoard() {
            mBoard.prevBoard();
        }

        @Override
        public void onNextBoard() {
            mBoard.nextBoard();
        }

        @Override
        public void onScale(int scale) {
            mBoard.setBoardScale(scale);
        }

        @Override
        public void onSetRatio(String ratio) {
            mBoard.setBoardRatio(ratio);
        }

        @Override
        public void onSetFitMode(int mode) {
            mBoard.setBoardContentFitMode(mode);
        }

        @Override
        public void onTransCodeFile(TEduBoardController.TEduBoardTranscodeFileResult myresult) {
            openPopWebview(kAddTranscodeUrl);
            moreDlg.dismiss();
        }

        @Override
        public void onAddH5File(String url) {
            openPopWebview(kAddH5Url);
            moreDlg.dismiss();
        }

        @Override
        public void onDeleteFile(String fileId) {
            mBoard.deleteFile(fileId);
        }

        @Override
        public void onGotoFile(String fid) {
            mBoard.switchFile(fid);
        }

        @Override
        public void onAddImagesFile(List<String> urls) {
            mImgsFid = mBoard.addImagesFile(urls,null,true);
        }

        @Override
        public void onAddWatermark() {
            TICClassMainActivity.this.openPopWebview(TICClassMainActivity.kAddWatermarkUrl);
            moreDlg.dismiss();
        }

        @Override
        public void onAddVideo() {
            TICClassMainActivity.this.openPopWebview(TICClassMainActivity.kAddVideoFileUrl);
            moreDlg.dismiss();
        }

        @Override
        public void onImportInLocalMode() {
            mBoard.setDataSyncEnable(false);
            mBoard.importInLocalMode(mDataExported);
            mBoard.setDataSyncEnable(true);
            moreDlg.dismiss();
        }

        @Override
        public void onExportInLocalMode() {
            mDataExported = mBoard.exportInLocalMode();
            moreDlg.dismiss();
            postToast(TextUtil.getString(R.string.data_saved_locally), true);
        }

        @Override
        public void onImportInLocalModeWithFilter() {
            mBoard.setDataSyncEnable(false);
            mBoard.importInLocalMode(mDataExported, "{\"include\":{\"types\":[801]}}");
            mBoard.setDataSyncEnable(true);
            moreDlg.dismiss();
        }

        @Override
        public void onExportInLocalModeWithFilter() {
            mDataExported = mBoard.exportInLocalMode("{\"include\":{\"types\":[801]}}");
            moreDlg.dismiss();
            postToast(TextUtil.getString(R.string.data_saved_locally), true);
        }

        @Override
        public void onHideElements() {
            List<String> ids = new ArrayList<>();
            List<Integer> types = new ArrayList<>();
            types.add(TEduBoardController.TEduBoardElementType.TEDU_BOARD_ELEMENT_GRAFFITI_LINE);
            mBoard.setElementsDisplay(types, ids, false);
            moreDlg.dismiss();
        }

        @Override
        public void onShowElements() {
            List<String> ids = new ArrayList<>();
            List<Integer> types = new ArrayList<>();
            types.add(TEduBoardController.TEduBoardElementType.TEDU_BOARD_ELEMENT_GRAFFITI_LINE);
            mBoard.setElementsDisplay(types, ids, true);
            moreDlg.dismiss();
        }

        @Override
        public void onAddAudio(String url, String title) {
            mBoard.addAudioElement(url, title);
        }

        @Override
        public void onPlayAudio() {
            if (!TextUtils.isEmpty(mAudioElementId)) {
                mBoard.playAudio(mAudioElementId);
                // mBoard.seekAudio(mAudioElementId, 120);
                //     mBoard.setAudioVolume(mAudioElementId,0.7f);
            }
        }

        @Override
        public void onPauseAudio() {
            if (!TextUtils.isEmpty(mAudioElementId)) {
                mBoard.pauseAudio(mAudioElementId);
                // mBoard.getAudioVolume(mAudioElementId);
                mBoard.getBoardElementList("");
            }

        }

        private List<String> getMediaList(Boolean isVideo) {
            List<String> result = new ArrayList<>();
            List<TEduBoardController.TEduBoardFileInfo> fileList = mBoard.getFileInfoList();
            for(int i = 0; i < fileList.size(); i++) {
                List<String> tmpList = isVideo ? fileList.get(i).mediaInfo.videoIDList : fileList.get(i).mediaInfo.audioIDList;
                if (tmpList != null && !tmpList.isEmpty()) {
                    result.addAll(tmpList);
                }
            }
            return result;
        }

        @Override
        public void onPlayPPPTVideo() {
            List<String> list = getMediaList(true);
            mBoard.playH5PPTVideo(list);
        }

        @Override
        public void onPausePPPTVideo() {
            List<String> list = getMediaList(true);
            mBoard.pauseH5PPTVideo(list);
        }

        @Override
        public void onPlayPPPTAudio() {
            List<String> list = getMediaList(false);
            mBoard.playH5PPTAudio(list);
        }

        @Override
        public void onPausePPPTAudio() {
            List<String> list = getMediaList(false);
            mBoard.pauseH5PPTAudio(list);
        }

        @Override
        public void onAddBackupDomain() {
            mBoard.addBackupDomain("https://test2.tencent.com", "http://b.hiphotos.baidu.com", 0);
        }

        @Override
        public void onRemoveBackupDomain() {
            mBoard.removeBackupDomain("https://test2.tencent.com", "http://b.hiphotos.baidu.com");

        }

        @Override
        public void onShowVideoCtrl(boolean value) {
            mBoard.showVideoControl(value);
        }

        @Override
        public void onSyncAndReload() {
            mBoard.syncAndReload();
        }

        @Override
        public void onSetSystemCursorEnable(boolean systemCursorEnable) {
            mBoard.setSystemCursorEnable(systemCursorEnable);
        }

        @Override
        public void onAddBoardToClassGroup(String groupId, String boardId) {
            mBoard.addBoardToClassGroup(groupId, boardId);
        }

        @Override
        public void onAddUserToClassGroup(String groupId, String userId) {
            mBoard.addUserToClassGroup(groupId, userId);
        }

        @Override
        public void onGetAllClassGroupIds() {
            mBoard.getAllClassGroupIds();
        }

        @Override
        public void onGetClassGroupEnable() {
            mBoard.getClassGroupEnable();
        }

        @Override
        public void onGetClassGroupIdByUserId(String userId) {
            mBoard.getClassGroupIdByUserId(userId);
        }

        @Override
        public void onGetClassGroupInfoByGroupId(String groupId) {
            mBoard.getClassGroupInfoByGroupId(groupId);
        }

        @Override
        public void onGotoClassGroupBoard(String boardId) {
            mBoard.gotoClassGroupBoard(boardId);
        }

        @Override
        public void onRemoveBoardInClassGroup(String groupId, String boardId) {
            mBoard.removeBoardInClassGroup(groupId, boardId);
        }

        @Override
        public void onRemoveClassGroup(String groupId) {
            mBoard.removeClassGroup(groupId);
        }

        @Override
        public void onRemoveUserInClassGroup(String groupId, String userId) {
            mBoard.removeUserInClassGroup(groupId, userId);
        }

        @Override
        public void onResetClassGroup() {
            mBoard.resetClassGroup();
        }

        @Override
        public void onSetClassGroup(String groupId, List<String> boards, List<String> users, String title, String currentBoardId) {
            mBoard.setClassGroup(groupId, boards, users, title, currentBoardId);
        }

        @Override
        public void onSetClassGroupEnable(boolean enable) {
            mBoard.setClassGroupEnable(enable);
        }

        @Override
        public void onSetClassGroupTitle(String groupId, String title) {
            mBoard.setClassGroupTitle(groupId, title);
        }

        @Override
        public void showToast(String toast) {
            postToast(toast, true);
        }
    }

    View boardview;

    void addBoardView() {
        mBoardContainer = (FrameLayout) findViewById(R.id.board_view_container);
        boardview = mBoard.getBoardRenderView();
        //  boardview.setBackgroundColor(Color.RED);
        FrameLayout.LayoutParams layoutParams = new FrameLayout.LayoutParams(FrameLayout.LayoutParams.MATCH_PARENT, FrameLayout.LayoutParams.MATCH_PARENT);
        //  mBoardContainer.addView(boardview, layoutParams);
//        mBoard.addBoardViewToContainer(mBoardContainer,boardview, layoutParams);
        mBoardContainer.addView(boardview);
//        boardview.setBackgroundColor(0); // 设置背景色
//        boardview.getBackground().setAlpha(0); // 设置填充透明度 范围：0-255
//        boardview.setVisibility(View.GONE);
        //  boardview.setBackgroundColor(getResources().getColor(R.color.colorRed));
     /*   TEduBoardController.TEduBoardColor boardColor = new TEduBoardController.TEduBoardColor(0, 0, 255, 1);
        mBoard.setBackgroundColor(boardColor);*/
        //   Log.d(TAG, "boardview tag: " + mBoard.getBoardRenderView().getTag());
     /*   DisplayMetrics dm = new DisplayMetrics();
        getWindowManager().getDefaultDisplay().getMetrics(dm);
        int width = dm.widthPixels;
        int height = dm.heightPixels;
        FrameLayout.LayoutParams linearParams = (FrameLayout.LayoutParams) boardview.getLayoutParams();
        linearParams.height = height;
        linearParams.width = width;
        boardview.setLayoutParams(linearParams);*/
       /* boardview.addOnLayoutChangeListener(new View.OnLayoutChangeListener() {
            @Override
            public void onLayoutChange(View v, int left, int top, int right, int bottom, int oldLeft, int oldTop, int oldRight, int oldBottom) {
                int width = v.getWidth();
                int height = v.getHeight();
                TLogger.i(TAG, "board_size_change mBoardContainer", "width:" + width + " height:" + height);
            }
        });*/

        //设置透明
        //boardview.setBackgroundColor(Color.TRANSPARENT);
        //boardview.getBackground().setAlpha(0); // 设置填充透明度 范围：0-255
        //mBoard.setGlobalBackgroundColor(new TEduBoardController.TEduBoardColor(0, 0,0, 0));
        //mBoard.setBackgroundColor(new TEduBoardController.TEduBoardColor(0, 0,10, 0));
        //mBoard.showVideoControl(false); //不显示视频控制栏
        postToast(TextUtil.getString(R.string.using_whiteboard) + TEduBoardController.getVersion(), true);
    }

    public void testBoardSizeChange(boolean change) {
        FrameLayout.LayoutParams linearParams = (FrameLayout.LayoutParams) boardview.getLayoutParams();
        if (change) {
            linearParams.height = 600;
            linearParams.width = 200;
        } else {
            DisplayMetrics dm = new DisplayMetrics();
            getWindowManager().getDefaultDisplay().getMetrics(dm);
            int width = dm.widthPixels;
            int height = dm.heightPixels;
            linearParams.height = height;
            linearParams.width = width;
        }
        boardview.setLayoutParams(linearParams);
    }

    private void removeBoardView() {
        if (mBoard != null) {
            View boardview = mBoard.getBoardRenderView();
            if (mBoardContainer != null && boardview != null) {
                mBoardContainer.removeView(boardview);
            }
        }
    }

    private void onTEBHistroyDataSyncCompleted() {
        mHistroyDataSyncCompleted = true;
        postToast(TextUtil.getString(R.string.history_sync_complete), false);
    }

    boolean isChange = true;

    @Override
    public void onClick(View v) {

        switch (v.getId()) {

            case R.id.tv_double_room_back_button: //返回
                quitClass();
          //      String expression = "f(x) = \\int_{-\\infty}^\\infty \\hat{f}(\\xi)\\,e^{2 \\pi i \\xi x} \\,d\\xi";
          //      mBoard.addElementFormula(expression);
                //     quitClass();
                //    testBoardSizeChange(isChange);
                //     isChange = !isChange;
                break;

            case R.id.tv_memu: //菜单
            {
                if (!mHistroyDataSyncCompleted) { //
                    postToast(TextUtil.getString(R.string.please_wait_for_history_sync), true);
                    return;
                }
                if (mySettingCallback == null) {
                    mySettingCallback = new MySettingCallback();
                }

                if (moreDlg == null) {
                    moreDlg = new TICMenuDialog(this, mySettingCallback);
                    moreDlg.setCurrentActivity(this);
                }


                TICMenuDialog.SettingCacheData settingCacheData = new TICMenuDialog.SettingCacheData();

                //trtc
                settingCacheData.AudioEnable = mEnableAudio;
                settingCacheData.AudioRoute = mEnableAudioRouteSpeaker;
                settingCacheData.CameraEnable = mEnableCamera;
                settingCacheData.CameraFront = mEnableFrontCamera;

                //board
                settingCacheData.isDrawEnable = mBoard.isDrawEnable();
                settingCacheData.isSynDrawEnable = mBoard.isDataSyncEnable();
                settingCacheData.isHandwritingEnable = mBoard.isHandwritingEnable();
                settingCacheData.ToolType = mBoard.getToolType();
                settingCacheData.BrushThin = mBoard.getBrushThin();
                settingCacheData.BrushColor = mBoard.getBrushColor().toInt();
                settingCacheData.TextColor = mBoard.getTextColor().toInt();
                settingCacheData.BackgroundColor = mBoard.getBackgroundColor().toInt();
                settingCacheData.GlobalBackgroundColor = mBoard.getGlobalBackgroundColor().toInt();
                settingCacheData.highlightColor = mBoard.getHighlighterColor().toInt();
                settingCacheData.TextSize = mBoard.getTextSize();
                settingCacheData.TextHeight = (int)(mBoard.getTextLineHeight() * 100);
                settingCacheData.ScaleSize = mBoard.getBoardScale();
                settingCacheData.ration = mBoard.getBoardRatio();
                settingCacheData.FitMode = mBoard.getBoardContentFitMode();
                settingCacheData.isAutoSelect = mAutoSelect;

                settingCacheData.TextStyle = mBoard.getTextStyle();
                settingCacheData.canRedo = mCanRedo;
                settingCacheData.canUndo = mCanUndo;

                settingCacheData.currentBoardId = mBoard.getCurrentBoard();
                settingCacheData.boardIds = mBoard.getBoardList();

                settingCacheData.currentFileId = mBoard.getCurrentFile();
                settingCacheData.files = mBoard.getFileInfoList();

                settingCacheData.isNickNameVisiable = nickNameVisiable;
                settingCacheData.isMultiTouch = mEnableMultiTouch;
                settingCacheData.isDisableTouch = mDisableTouch;
                settingCacheData.magicPenType = mMagicPenType;
                settingCacheData.EraserSize = mBoard.getEraserSize();
                settingCacheData.isSegmentEraser = mSegmentEraser;
                moreDlg.show(settingCacheData);
            }
            break;

        }
    }

    @Override
    public void onBackPressed() {
        quitClass();
    }

    /**
     * 进入课堂
     */
    private void joinClass() {

        //1、设置白板的回调
        mBoardCallback = new MyBoardCallback(this);

        // 1、 IM进房
        final Context ctx = this;
        IMManager.getInstance().joinIMGroup(mGroupID, new IMManager.IMCallBack() {
            @Override
            public void onComplete(int errCode, String errMsg) {
                if (errCode == 0) {
                    // 2、 创建白板
                    mBoard = BoardManager.getInstance().creteBoard(ctx, sdkAppId, mUserID, mUserSig, mRoomId, mGroupID, mNickName,
                            new BoardManager.CreateBoardCallBack() {
                                @Override
                                public void onCreteBoard(int errCode, String errMsg, TEduBoardController boardController) {
                                    if (errCode == 0) {
                                        postToast(TextUtil.getString(R.string.enter_classroom_success) + mRoomId);
                                    }
                                    else  {
                                        postToast(TextUtil.getString(R.string.enter_classroom_failed) + mRoomId + " err:" + errCode + " msg:" + errMsg);
                                    }

                                }
                            });
                    mBoard.addCallback(mBoardCallback);
                }
                else {
                    postToast(TextUtil.getString(R.string.enter_classroom_failed) + mRoomId + " err:" + errCode + " msg:" + errMsg);
                }
            }
        });

    }

    private void quitClass() {
        if (mBoard != null) {
            mBoard.removeCallback(mBoardCallback);
        }
        BoardManager.getInstance().destroyBoard();

        IMManager.getInstance().quitIMGroup(String.valueOf(mRoomId), new IMManager.IMCallBack(){
            @Override
            public void onComplete(int errCode, String errMsg) {
                if (errCode == 0) {
                    postToast("quitClassroom#onSuccess", true);
                    finish();
                }
                else {
                    postToast("quitClassroom#onError: errCode = " + errCode + "  description " + errMsg);
                    finish();
                }
            }
        });
    }

    /**
     * 退出课堂
     */
    public void onQuitClsssroomClick(View v) {
        quitClass();
    }

    //---------------------- TICEventListener-----------------
    @Override
    public void onTIMForceOffline() {
        super.onTIMForceOffline();
        quitClass();
    }

    // IM掉线
    @Override
    public void onConnectFailed(int code, String error) {
        super.onConnectFailed(code,error);
        quitClass();
    }

    //Board Callback
    private class MyBoardCallback implements TEduBoardController.TEduBoardCallback {
        WeakReference<TICClassMainActivity> mActivityRef;

        MyBoardCallback(TICClassMainActivity activityEx) {
            mActivityRef = new WeakReference<>(activityEx);
        }

        @Override
        public void onTEBError(int code, String msg) {
            // 签名过期  退出教室
            if (code == TEduBoardController.TEduBoardErrorCode.TEDU_BOARD_SIGNATURE_EXPIRED) {
                TICClassMainActivity activity = mActivityRef.get();
                activity.postToast(TextUtil.getString(R.string.user_sig_expired));
                IMManager.getInstance().kickout();
                BoardManager.getInstance().destroyBoard();
                if (activity != null) {
                    activity.quitClass();
                }
            }

        }

        @Override
        public void onTEBWarning(int code, String msg) {
            TICClassMainActivity activity = mActivityRef.get();
            if (code == TEduBoardController.TEduBoardWarningCode.TEDU_BOARD_WARNING_IMAGE_WATERMARK_ALREADY_EXISTS) {
                activity.postToast(TextUtil.getString(R.string.image_watermark_exists), true);
            } else if(code == TEduBoardController.TEduBoardWarningCode.TEDU_BOARD_WARNING_VIDEO_ALREADY_EXISTS) {
                activity.postToast(TextUtil.getString(R.string.duplicate_add_file), true);
            } else if(code == TEduBoardController.TEduBoardWarningCode.TEDU_BOARD_WARNING_H5PPT_ALREADY_EXISTS) {
                activity.postToast(TextUtil.getString(R.string.duplicate_add_file), true);
            } else if(code == TEduBoardController.TEduBoardWarningCode.TEDU_BOARD_WARNING_H5FILE_ALREADY_EXISTS) {
                activity.postToast(TextUtil.getString(R.string.duplicate_add_file), true);
            } else if(code == TEduBoardController.TEduBoardWarningCode.TEDU_BOARD_WARNING_IMAGESFILE_ALREADY_EXISTS) {
                activity.postToast(TextUtil.getString(R.string.duplicate_add_file), true);
            } else if(code == TEduBoardController.TEduBoardWarningCode.TEDU_BOARD_WARNING_IMAGE_COURSEWARE_ALREADY_EXISTS) {
                activity.postToast(TextUtil.getString(R.string.duplicate_add_file), true);
            }
        }

        @Override
        public void onTEBInit() {
            TICClassMainActivity activity = mActivityRef.get();
            if (activity != null) {
                activity.addBoardView();
            }
        }

        @Override
        public void onTEBHistroyDataSyncCompleted() {
            TICClassMainActivity activityEx = mActivityRef.get();
            if (activityEx != null) {
                activityEx.onTEBHistroyDataSyncCompleted();
                String currentBoard = activityEx.mBoard.getCurrentBoard();
                String currentFile = activityEx.mBoard.getCurrentFile();
                Log.w("DataSyncCompleted", "currentBoard: " + currentBoard + " currentFile: " + currentFile);
            }
        }

        @Override
        public void onTEBSyncData(String data) {

        }


        @Override
        public void onTEBScrollChanged(String boardId, int trigger, double scrollLeft, double scrollTop, double scale) {

        }

        @Override
        public void onTEBAddBoard(List<String> boardId, final String fileId) {
        }

        @Override
        public void onTEBDeleteBoard(List<String> boardId, final String fileId) {
        }

        @Override
        public void onTEBGotoBoard(String boardId, final String fileId, String userId) {

        }

        @Override
        public void onTEBGotoStep(int currentStep, int total) {
        }

        @Override
        public void onTEBRectSelected() {
        }

        @Override
        public void onTEBRefresh() {
        }

        @Override
        public void onTEBOfflineWarning(int count) {

        }

        @Override
        public void onTEBDeleteFile(String fileId) {
        }

        @Override
        public void onTEBSwitchFile(String fileId) {
        }

        @Override
        public void onTEBAddTranscodeFile(String s) {
        }

        @Override
        public void onTEBUndoStatusChanged(boolean canUndo) {
            TICClassMainActivity activityEx = mActivityRef.get();
            if (activityEx != null) {
                activityEx.mCanUndo = canUndo;
                if (activityEx.moreDlg != null) {
                    activityEx.moreDlg.updateCanUndo(canUndo);
                }
            }
        }

        @Override
        public void onTEBRedoStatusChanged(boolean canredo) {
            TICClassMainActivity activityEx = mActivityRef.get();
            if (activityEx != null) {
                activityEx.mCanRedo = canredo;
                if (activityEx.moreDlg != null) {
                    activityEx.moreDlg.updateCanRedo(canredo);
                }
            }

        }

        @Override
        public void onTEBFileUploadProgress(final String path, int currentBytes, int totalBytes, int uploadSpeed, float percent) {
        }

        @Override
        public void onTEBFileUploadStatus(final String path, int status, int code, String statusMsg) {
        }

        @Override
        public void onTEBFileTranscodeProgress(String s, String s1, String s2, TEduBoardController.TEduBoardTranscodeFileResult tEduBoardTranscodeFileResult) {

        }

        @Override
        public void onTEBH5FileStatusChanged(String fileId, int status) {

        }

        @Override
        public void onTEBAddImagesFile(final String fileId) {
            Log.i(TAG, "onTEBAddImagesFile:" + fileId);
            // All TEduBoard get methods should not be called in main thread, it may cause unexpected problems in HarmonyOS
            new Thread(new Runnable() {
                @Override
                public void run() {
                    TICClassMainActivity activityEx = mActivityRef.get();
                    TEduBoardController.TEduBoardFileInfo fileInfo = activityEx.mBoard.getFileInfo(fileId);
                }
            }).start();
        }

        @Override
        public void onTEBVideoStatusChanged(String fileId, int status, float progress, float duration) {
            if (status == TEduBoardController.TEduBoardVideoStatus.TEDU_BOARD_VIDEO_STATUS_ERROR) {
                mActivityRef.get().postToast(TextUtil.getString(R.string.video_play_load_failed), true);
            }
            Log.i(TAG, "onTEBVideoStatusChanged:" + fileId + " | " + status + "|" + progress);

        }

        @Override
        public void onTEBAudioStatusChanged(String elementId, int status, float progress, float duration) {
            Log.i(TAG, "onTEBAudioStatusChanged:" + elementId + " | " + status + "|" + progress);
        }

        @Override
        public void onTEBSnapshot(String path, int code, String msg) {
            Log.i(TAG, "onTEBSnapshot:" + path + " | " + code + "|" + msg);
            if (code == 0) {
                mActivityRef.get().postToast(TextUtil.getString(R.string.screenshot_success) + path, true);
                mActivityRef.get().sendBroadcast(new Intent(Intent.ACTION_MEDIA_SCANNER_SCAN_FILE, Uri.parse("file://" + path)));
            }
        }

        @Override
        public void onTEBBoardElementLockedChanged(List<String> elementIds, boolean locked) {

        }

        @Override
        public void onTEBH5PPTStatusChanged(int statusCode, String fid, String describeMsg) {
            if (fid.length() > 0 && statusCode == TEduBoardController.TEduBoardH5PPTStatus.TEDU_BOARD_H5_PPT_STATUS_LOADED) {
                mActivityRef.get().postToast(fid + "加载完成");
            } else if (fid.length() > 0) {
//[self addMsgInChatView:[NSString stringWithFormat:@"H5PPTStatusChanged, fileId = %@, status = %ld, message = %@", fileId, (long)status, message]];
                mActivityRef.get().postToast("H5PPTStatusChanged, fileId = " + fid + ", status = " + statusCode + ", message = " + describeMsg);
            }
        }

        @Override
        public void onTEBH5PPTMediaStatusChanged(String fid, String mediaId, int status, final double currentTime) {
            mActivityRef.get().postToast("H5PPTMediaStatusChanged, fid = " + fid + ", mediaId = " + mediaId+ ", status = " + status + ", currentTime = " + currentTime);
        }

        @Override
        public void onTEBTextElementStatusChange(String status, String id, String value, int left, int top) {
            Log.e(TAG, "onTEBTextComponentStatusChange textH5Status:" + status + " textH5Id:" + id);

            TICClassMainActivity activityEx = mActivityRef.get();
            if (activityEx != null) {
                activityEx.textH5Id = id;
                activityEx.textH5Status = status;
            }
        }

        @Override
        public void onTEBClassGroupStatusChanged(boolean enable, String classGroupId, int operationType, String message) {

        }

        @Override
        public void onTEBCursorPositionChanged(Point point) {

        }

        @Override
        public void onTEBImageStatusChanged(String boardId, String url, int status) {
            if (status == TEduBoardController.TEduBoardImageStatus.TEDU_BOARD_IMAGE_STATUS_LOAD_ERROR
                    || status == TEduBoardController.TEduBoardImageStatus.TEDU_BOARD_IMAGE_STATUS_LOAD_TIMEOUT) {
                mActivityRef.get().postToast(TextUtil.getString(R.string.courseware_load_failed), true);
            }
        }

        @Override
        public void onTEBSetBackgroundImage(final String url) {
            Log.i(TAG, "onTEBSetBackgroundImage:" + url);
        }

        @Override
        public void onTEBAddImageElement(final String url) {
            Log.i(TAG, "onTEBAddImageElement:" + url);
        }

        @Override
        public void onTEBAddElement(String id, int type, String url) {
            addLog("白板元素添加成功，elementId = " + id + ", type = " + type);
            if (mAutoSelect && type == 13) {
                mBoard.autoSelectedElement(id);
            }
        }

        @Override
        public void onTEBDeleteElement(List<String> id) {

        }

        @Override
        public void onTEBSelectElement(List<TEduBoardController.ElementItem> elementItemList) {
            addLog("onTEBSelectElement...");
            TICClassMainActivity activityRef = TICClassMainActivity.this;
            if (elementItemList.size() > 0) {
                TEduBoardController.ElementItem item = elementItemList.get(0);
                activityRef.currentElement = activityRef.mBoard.getElementById(item.elementId);
                activityRef.openPopWebview(TICClassMainActivity.kUpdateElementUrl);
                JSONObject paramsObj = new JSONObject();
                try {
                    paramsObj.putOpt("title", activityRef.currentElement.title);
                    paramsObj.put("type", activityRef.currentElement.type);
                    if (activityRef.currentElement.style != null) {
                        String borderColorKey = String.format("%d", TEduBoardController.TEduElementOperatorType.BOARDER_COLOR);
                        paramsObj.putOpt(borderColorKey, activityRef.currentElement.style.borderColor);

                        String borderWidthKey = String.format("%d", TEduBoardController.TEduElementOperatorType.BOARDER_WIDTH);
                        paramsObj.put(borderWidthKey, activityRef.currentElement.style.borderWidth);

                        String borderTypeKey = String.format("%d", TEduBoardController.TEduElementOperatorType.BOARDER_LINE_TYPE);
                        paramsObj.put(borderTypeKey, activityRef.currentElement.style.borderType);

                        String positionKey = String.format("%d", TEduBoardController.TEduElementOperatorType.CHANGE_POSITION);
                        JSONObject positionObj = new JSONObject();
                        positionObj.put("x", item.left);
                        positionObj.put("y", item.top);
                        paramsObj.putOpt(positionKey, positionObj);

                        String textSizeKey = String.format("%d", TEduBoardController.TEduElementOperatorType.CHANGE_TEXTSIZE);
                        paramsObj.put(textSizeKey, activityRef.currentElement.textSize);
                    }
                    activityRef.popWebView.sendToH5("setElementInfo", paramsObj);
                } catch (Exception e) {

                }
            }
        }

        @Override
        public void onTEBMathGraphEvent(int code, String boardId, String graphId, String message) {

        }

        @Override
        public void onTEBZoomDragStatus(String fid, int scale, int xOffset, int yOffset) {

        }

        @Override
        public void onTEBBackgroundH5StatusChanged(String boardId, String url, int status) {
            Log.i(TAG, "onTEBBackgroundH5StatusChanged:" + boardId + " url:" + boardId + " status:" + status);
        }

        @Override
        public void onTEBTextElementWarning(String code, String message) {

        }

        @Override
        public void onTEBImageElementStatusChanged(int status, String currentBoardId, String imgUrl, String currentImgUrl) {

        }

        @Override
        public void onTEBElementPositionChange(List<TEduBoardController.ElementItem> elementItemList, int status) {
            if (elementItemList.size() > 0) {
                TEduBoardController.ElementItem item = elementItemList.get(0);
                Log.i(TAG, String.format("onTEBElementPositionChange: %s, status: %d", item.toString(), status));
            }
        }

        @Override
        public void onTEBPermissionChanged(List<String> permissions, Map<String, List<String>> filters) {

        }

        private long lastToastTime = 0;
        @Override
        public void onTEBPermissionDenied(String permission) {
            long time = System.currentTimeMillis();
            if (time - this.lastToastTime >= 2000) {
                this.lastToastTime = time;
                mActivityRef.get().postToast(TextUtil.getString(R.string.insufficient_permission) + permission, true);
            }

        }

        @Override
        public void onTEBImportInLocalModeCompleted(int code) {

        }

        @Override
        public void onTEBScaleChanged(String boardId, double scale, double xOffset, double yOffset) {
            String msg = "收到白板缩放事件, boardId = " + boardId + "，scale =" + scale + "，xOffset =" + xOffset + "，yOffset =" + yOffset;
            Log.i("TEduBoardCallback", msg);
            addLog(msg);
        }

        @Override
        public void onTEBDrawStatusChanged(int status) {
            String msg = status == 1 ? TextUtil.getString(R.string.start_drawing) : TextUtil.getString(R.string.end_drawing);
            Log.i("TEduBoardCallback", msg);
            addLog(msg);
        }

        @Override
        public void onTEBH5pptDownGrade(String fileId, int slideIndex) {
            String msg = "PPT加载超时(fid=" + fileId + ")，将进行降级渲染";
            addLog(msg);
            mBoard.setDownGradeEnable(fileId, slideIndex, true);
        }
    }


}
